package com.zipcodewilmington.gildedrose;


public class Inventory {
    private Item[] items;
    private int maxQuality = 50;
    private int legendaryQuality = 80;

    public Inventory(Item[] items) {
        super();
        this.items = items;
    }



    //insert method to set this.items = adjustItems(this.items)

    public Item[] adjustItems(Item[] items) {
        for (Item item : items) {
            if (item.getName().equals("Sulfuras, Hand of Ragnaros")) {
                item = sulfurasHandler(item);
            } else if (item.getName().equals("Aged Brie")) {
                item = agedBrieHandler(item);
            } else if (item.getName().equals("Backstage passes to a TAFKAL80ETC concert")) {
                item = backstagePassHandler(item);
            }
        }
        return items;
    }

    public Item sulfurasHandler(Item legendaryItem) {
        legendaryItem.setQuality(legendaryQuality);
        return legendaryItem;
    }

    public Item agedBrieHandler(Item item) {
        int x = 1;
        int quality = item.getQuality();
        if (isMaxQuality(quality) && !itemIsExpired(item)) {
            return item;
        } else if (itemIsExpired(item)) {
            x = -2;
        }
        adjustItemQuality(item, x);
        adjustItemSellIn(item);
        return item;
    }

    public Item backstagePassHandler(Item item) {
        int x = 0;
        int sellIn = item.getSellIn();
        if (isMaxQuality(item.getQuality()) && !itemIsExpired(item)) return item;
        else if (sellIn >= 10) {
            x = 1;
        } else if (sellIn >= 5) {
            x = 2;
        } else if (sellIn > 0) {
            x = 3;
        } else {
            x = item.getQuality() * -1;
        }
        adjustItemQuality(item, x);
        adjustItemSellIn(item);
        return item;
    }

    public boolean isMaxQuality(int n) {

        return n == maxQuality;
    }

    public boolean itemIsExpired(Item i) {
        return i.getSellIn() <= 0;
    }

    public void adjustItemQuality(Item i, Integer n) {
        int q = i.getQuality();
        int result = q + n;
        if (result < 0) {
            i.setQuality(0);
        } else if (result <= maxQuality) {
            i.setQuality(result);
        }  else {
            i.setQuality(maxQuality);
        }
    }

    public void adjustItemSellIn(Item i) {
        i.setSellIn(i.getSellIn() - 1);
    }
}